#include <stdio.h>
#include "defs.h"

void
allocate_tensor_patch(ptpPatch)
TENSOR_PATCH	*ptpPatch;
{ 
  POINT4D	*p4dCoeff_space;
  int		tot_space;
  int		i, j;

  /* allocate memory */
#if 1
  tot_space = (ptpPatch->iDeg0+1)*(ptpPatch->iDeg1+1);
  ALLOCN(ptpPatch->coeffs, POINT4D *, (ptpPatch->iDeg0+1));
  ALLOCN(p4dCoeff_space, POINT4D, tot_space);

  /* set up pointers */
  for(i = j = 0; i <=  ptpPatch->iDeg0; i++)
  { ptpPatch->coeffs[i] = &p4dCoeff_space[j];
    j+= (ptpPatch->iDeg1 + 1);
  }
#else
  ALLOCN(ptpPatch->coeffs, POINT4D *, (ptpPatch->iDeg0+1));
  for (i=0; i<=ptpPatch->iDeg0; i++)
    ALLOCN(ptpPatch->coeffs[i], POINT4D, (ptpPatch->iDeg1+1));
#endif
}
