#ifndef _partition_h
#define _partition_h

#ifdef __LINK
#include <defs.h>
#endif

#include <intersect.h> 

extern int is_point_inside_polygon(int, double vertices[][2], point_typ *);
extern int is_simple_polygon(int, int);
extern int find_point_inside_polygon(int, double vertices[][2],
				     point_typ *);
extern int partition_polygon(TRIM_PORTION_TYPE *,
			     DOMAIN_INT_CURVE *, int,
			     TRIM_PATCH_INFO *, neighbour_t *);
extern int is_curve_anticlockwise(double curve[][2], int);
extern int is_point_within_polygon(point_typ *);

extern int trace_around_edges(part_t *);

#endif /* _partition_h */
