/* Look at */
/* keeping #points along the boundary curve constant CHANGE!!! */
/* Add Error control, e.g Size of arrays */
#ifdef __GL
#define SGIDEF1
#include <gl/sphere.h>
#include "defs.h"
#include "colortrim.h"
#include "hostgptrim.h"
#include "triangles.h"
#include "BezVars.h"

#define FILENAMESIZE	100
#define QUIT		99

extern double Sphradius;
extern double Scale;
extern int sp;
extern int changed_patch;

#define MAXTRI          ((MAX_NO_POINTS-1)*(MAX_NO_POINTS-1)*2)
int tindex[MAX_PATCH_GP];
WTYPE     keep[MAX_PATCH_GP][MAXTRI][3][2][3];


int cdebug, debug, nsteps;
int freeze=0, patchno, numpatches, arbit=1;
int subdiv = 0;
int num_of_first_patch;
WTYPE tolerance, r, rx, ry, rz, ex, ey, ez;
WTYPE vx, vy, vz, hx, hz, tanxy, hither, yon, fov;
WTYPE curvparam, uvlen, luv, ruv;
WTYPE hCURVPARAM, hDIVPARAM, hTOLERANCE;
WTYPE cntrl[MAX_PATCH][MAX_ORDER][MAX_ORDER][WCOORD];
TPOINT curve[MAX_PATCH][MAX_TRIMCURVE][MAX_CDEGREE];
TPOINT *pcurve[MAX_TRIMCURVE];
int ncurves[MAX_PATCH];
short  cdegree[MAX_PATCH][MAX_TRIMCURVE];
int cnt, fill, ros_gpnum = 1;
Matrix M1, Mp, Mpi, Mmpi, pMmpi;
Matrix Ident = {{1.0,0.0,0.0,0.0},{0.0,1.0,0.0,0.0},{0.0,0.0,1.0,0.0},{0.0,0.0,0.0,1.0}}; 
WTYPE realarea();
int udegree[MAX_PATCH], vdegree[MAX_PATCH]; 
double intpoints[10000][3];
double dispx, dispy, dispz;
int   ip=0;
int curve_or_full = 0;
int multi_color = 0;
float sphere[4];


WTYPE maux1[MAX_PATCH_GP][MAX_NO_POINTS2][MAX_NO_POINTS2][WCOORD];
WTYPE maux2[MAX_PATCH_GP][MAX_NO_POINTS2][MAX_NO_POINTS2][WCOORD];
WTYPE mcurvpt[MAX_PATCH_GP][2][MAX_NO_POINTS2][WCOORD];
WTYPE mcurvn1[MAX_PATCH_GP][2][MAX_NO_POINTS2][WCOORD];

draw_the_patches(filename, solid1, nsolid1, solid2, nsolid2, spr, rf, str)
char *filename;
char *str;
TRIM_PATCH_INFO *solid1, *solid2;
int  spr, rf, nsolid1, nsolid2;
{
int gp, total = 0;
short si, sj;
char op;
int autom, l, full, all, Rx, Ry, Rz, nohull;
int insteps[2][2];
WTYPE tmp1, tmp2;
WTYPE fx, fy, fz, area, divparam;
double minx, miny, minz, maxx, maxy, maxz, tmpx, tmpy, tmpz;
int i, j, k, m, n, itn, nusteps, nvsteps;
WTYPE cntrlp[MAX_DEGREE*MAX_DEGREE][WCOORD];
WTYPE cntrlp1[MAX_ORDER][MAX_ORDER][WCOORD];
int index[MAX_DEGREE*MAX_DEGREE];
WTYPE step_xyz, t;
POINT pt, pt1, pt3, pt4, pt5, pt6;
struct timeval BeginTime, EndTime;
struct timezone TimeZone;
Matrix Pt, MI;
double QQ[4][4];
DlistGlobalsType *dglob;
int ret_val_of_getinput, num_of_second_patch;
int separate, colr_ind;
FILE *fp, *fp1;

   debug = cdebug = 0;
   nsteps = NSTEPS;
   nusteps = nvsteps = 200;
   divparam = DIVPARAM;
   curvparam = CURVPARAM;
   tolerance = TOLERANCE;
   separate = spr;

   minx = miny = minz = HUGE_VAL;
   maxx = maxy = maxz = -HUGE_VAL;
   gp = 0;
   i = 1; fill = 1; full = 0; all = 0, autom = 1;
   hDIVPARAM = divparam, hCURVPARAM = curvparam, hTOLERANCE = SCREENTOL;

   Mpi[0][0] = -0.980582;
   Mpi[0][1] = 0.0;
   Mpi[0][2] = 0.196116;
   Mpi[0][3] = 0.0;

   Mpi[1][0] = -0.0377426;
   Mpi[1][1] = 0.981308;
   Mpi[1][2] = -0.188713;
   Mpi[1][3] = 0.0;

   Mpi[2][0] = -0.19245;
   Mpi[2][1] = -0.19245;
   Mpi[2][2] = -0.96225;
   Mpi[2][3] = 0.0;

   Mpi[3][0] = 0.0;
   Mpi[3][1] = 0.0;
   Mpi[3][2] = -2.0;
   Mpi[3][3] = 1.0;

   cnt = 0;
if (strcmp(filename,"")) {
   fp = fopen(filename, "r");
   if(fp == NULL) {perror(filename); exit(1);}
   fscanf(fp, "%d", &num_of_first_patch);
   fscanf(fp, "%d", &num_of_second_patch);
   while(1)
   {
      if(fscanf(fp, "%d %d", udegree+cnt, vdegree+cnt) == EOF)
      {
         Printf("End of patches\n");
         break;
      }
       /* ncurves[cnt] = 0; */
      for(i=0; i<=udegree[cnt]; i++)
         for(j=0; j<=vdegree[cnt]; j++)
 	 {
            for(k=0; k<WCOORD; k++)
	       fscanf(fp, "%f", &(cntrl[cnt][i][j][k]));
/*
	    tmpz = 1.0/cntrl[cnt][i][j][3];
	    tmpx = cntrl[cnt][i][j][0] * tmpz;
	    tmpy = cntrl[cnt][i][j][1] * tmpz;
	    tmpz = cntrl[cnt][i][j][2] * tmpz;
	    if (tmpx < minx)
	      minx = tmpx;
	    if (tmpx > maxx)
	      maxx = tmpx;

	    if (tmpy < miny)
	      miny = tmpy;
	    if (tmpy > maxy)
	      maxy = tmpy;

	    if (tmpz < minz)
	      minz = tmpz;
	    if (tmpz > maxz)
	      maxz = tmpz;
*/
 	 }
      if(cnt > MAX_PATCH) {printf("Too many Patches\n"); exit(0);}
      cnt++;
   }
   fclose(fp);
} else if (!strcmp(filename,"")) {
   num_of_first_patch = nsolid1;
   num_of_second_patch = nsolid2;
   if (num_of_first_patch+num_of_second_patch>MAX_PATCH) {
     printf("Too many Patches\n");
     exit(0);
   }
   for (i=0; i<num_of_first_patch; i++) {
     udegree[cnt] = solid1[i].tp.iDeg0;
     vdegree[cnt] = solid1[i].tp.iDeg1;
     for (j=0; j<=udegree[cnt]; j++)
     for (k=0; k<=vdegree[cnt]; k++) {
       for (l=0; l<=2; l++)
	 cntrl[cnt][j][k][l] = Scale*
			       (solid1[i].tp.coeffs[j][k].dCoord[l]);
       cntrl[cnt][j][k][3] = solid1[i].tp.coeffs[j][k].dCoord[3];
       tmpz = 1.0/cntrl[cnt][j][k][3];
       tmpx = cntrl[cnt][j][k][0] * tmpz;
       tmpy = cntrl[cnt][j][k][1] * tmpz;
       tmpz = cntrl[cnt][j][k][2] * tmpz;
       if (tmpx < minx)
	 minx = tmpx;
       if (tmpx > maxx)
	 maxx = tmpx;
       
       if (tmpy < miny)
	 miny = tmpy;
       if (tmpy > maxy)
	 maxy = tmpy;
       
       if (tmpz < minz)
	 minz = tmpz;
       if (tmpz > maxz)
	 maxz = tmpz;
/* */
     }
     ncurves[cnt] = solid1[i].NumTrimPortions;
     for (m=0; m<ncurves[cnt]; m++) {
       cdegree[cnt][m] = solid1[i].TrimPortion[m].NumOfVertices;
       for (n=0; n<=cdegree[cnt][m]; n++) {
	 curve[cnt][m][n][0] = solid1[i].TrimPortion[m].poly_vertex[n][0];
	 curve[cnt][m][n][1] = solid1[i].TrimPortion[m].poly_vertex[n][1];
       }
     }
     cnt++;
   }
   for (i=0; i<num_of_second_patch; i++) {
     udegree[cnt] = solid2[i].tp.iDeg0;
     vdegree[cnt] = solid2[i].tp.iDeg1;
     for (j=0; j<=udegree[cnt]; j++)
     for (k=0; k<=vdegree[cnt]; k++) {
       for (l=0; l<=2; l++)
	 cntrl[cnt][j][k][l] = Scale*
			       (solid2[i].tp.coeffs[j][k].dCoord[l]);
       cntrl[cnt][j][k][3] = solid2[i].tp.coeffs[j][k].dCoord[3];
       tmpz = 1.0/cntrl[cnt][j][k][3];
       tmpx = cntrl[cnt][j][k][0] * tmpz;
       tmpy = cntrl[cnt][j][k][1] * tmpz;
       tmpz = cntrl[cnt][j][k][2] * tmpz;
       if (tmpx < minx)
	 minx = tmpx;
       if (tmpx > maxx)
	 maxx = tmpx;
       
       if (tmpy < miny)
	 miny = tmpy;
       if (tmpy > maxy)
	 maxy = tmpy;
       
       if (tmpz < minz)
	 minz = tmpz;
       if (tmpz > maxz)
	 maxz = tmpz;
/* */
     }
     ncurves[cnt] = solid2[i].NumTrimPortions;
     for (m=0; m<ncurves[cnt]; m++) {
       cdegree[cnt][m] = solid2[i].TrimPortion[m].NumOfVertices;
       for (n=0; n<=cdegree[cnt][m]; n++) {
	 curve[cnt][m][n][0] = solid2[i].TrimPortion[m].poly_vertex[n][0];
	 curve[cnt][m][n][1] = solid2[i].TrimPortion[m].poly_vertex[n][1];
       }
     }
     cnt++;
   }
}
   printf("%d Patches read\n", cnt);

/* */
   rx = (minx + maxx)/2.0;
   ry = (miny + maxy)/2.0;
   rz = (minz + maxz)/2.0;

   dispx = rx;
   dispy = ry;
   dispz = rz;

   for (i=0; i<cnt; i++) 
     for (j=0; j<=udegree[i]; j++)
       for (k=0; k<=vdegree[i]; k++) {
	 cntrl[i][j][k][0] -= cntrl[i][j][k][3]*dispx;
	 cntrl[i][j][k][1] -= cntrl[i][j][k][3]*dispy;
	 cntrl[i][j][k][2] -= cntrl[i][j][k][3]*dispz;
       }

#ifdef WRITE_INTO_FILE
   fp1 = fopen("test", "w");
   for (i=0; i<cnt; i++) {
     fprintf(fp1, "%d %d\n", udegree[i], vdegree[i]);
     for (j=0; j<=udegree[i]; j++)
       for (k=0; k<=vdegree[i]; k++) {
	 for (l=0; l<4; l++)
	   fprintf(fp1, "%g ", cntrl[i][j][k][l]);
	 fprintf(fp1, "\n");
       }
     fprintf(fp1, "%d\n", ncurves[i]);
     for (j=0; j<ncurves[i]; j++) {
       fprintf(fp1, "%d 1\n", cdegree[i][j]);
       for (k=0; k<=cdegree[i][j]; k++)
	 fprintf(fp1, "%g %g\n", curve[i][j][k][0],
		 curve[i][j][k][1]);
     }
   }
   fclose(fp1);
#endif

/* */
   tmp1 = maxx - minx;
   if (tmp1 < (maxy-miny)) tmp1 = maxy-miny;
   if (tmp1 < (maxz-minz)) tmp1 = maxz - minz;
   rx = ry = rz = 0.0; 

   ex = rx + tmp1;
   ey = ry + tmp1;
   ez = rz + tmp1;

/*
   getmatrix(M1);
   for (i=0;i<4;i++) {
     for (j=0;j<4;j++)
       printf("%g ", M1[i][j]);
     printf("\n");
   }
   printf("EYE: %g %g %g\n", ex,ey,ez);
   printf("REF: %g %g %g\n", rx,ry,rz);
*/
   loadmatrix(Ident);
   lookat(ex, ey, ez, rx, ry, rz, 0);

/*
   getmatrix(M1);
   printf("\n");
   for (i=0;i<4;i++) {
     for (j=0;j<4;j++)
       printf("%g ", M1[i][j]);
     printf("\n \n");
   }
   sleep(3);
*/

   uvlen = 1-2*tolerance;
   luv = tolerance;
   ruv = 1-tolerance;

   CPrintf("nsteps = %d\n", nsteps);
   /* HAck to not have to change init */
   l = cdebug; cdebug = !autom;
    /* init_gl(); */
   cdebug = l;
   if(autom) init_events();

   getmatrix(M1); 
   getmatrix(Mp);
   /* changed_patch = Compute = 1; */
   for(i=0; i<cnt; i++)
      patchinit[i] = 0;
   while(1)
   {
      if(!autom)
      {
	  /* loadmatrix(MI); */
         printf("op ? ");
    	 scanf("%c", &op);
   	 if(op == 'q') exit(0);
   	 if(op == 'r') scanf("%d %d %d", &Rx, &Ry, &Rz);
   	 else scanf("%f %f %f", &fx, &fy, &fz);
   	 getc(stdin);

         pushmatrix();
         if(op == 'r')
         {
            rot(Rx, 'X'); rot(Ry, 'Y'); rot(Rz, 'Z');
         }
         else if(op == 's')
            scale(fx, fy, fz);
         else if(op == 't')
         translate(fx, fy, fz);
	  /* getmatrix(M1); */
  
      }
      else {
        ret_val_of_getinput = getinput();
        if (ret_val_of_getinput == QUIT) {
	  if (0 /*rf*/) {
	    fp1 = fopen("MATRIX", "r");
	    for (i=0; i<4; i++)
	    for (j=0; j<4; j++) {
	      fscanf(fp1, "%lf", &(QQ[i][j]));
	      M1[i][j] = QQ[i][j];
	    }
	    fclose(fp1);
	  }
	  else getmatrix(M1);
/*
	  for (i=0; i<4; i++, printf("\n"))
	  for (j=0; j<4; j++) 
 	    printf("%15.9lf,  ", M1[i][j]);
	  for (i=0; i<4; i++, printf("\n"))
	  for (j=0; j<4; j++) 
 	    printf("%15.9lf,  ", Mp[i][j]);
          for (i=0; i<4; i++)
          for (j=0; j<4; j++) {
            Mmpi[i][j] = 0.0;
            for (k=0; k<4; k++)
              Mmpi[i][j] += M1[i][k] * Mpi[k][j];
          }
          for (i=0; i<4; i++)
          for (j=0; j<4; j++) {
            pMmpi[i][j] = 0.0;
            for (k=0; k<4; k++)
              pMmpi[i][j] += Mpi[i][k] * M1[k][j];
          }
*/
	   /* loadmatrix(Mp); */
	  if (0/*rf*/) {
            c3f(purplevec);
            clear();
            zclear();
	    draw_patch_xyz(1);
	  }
	  return;
	}
      }

      c3f(purplevec);
      clear();
      zclear();

      pushmatrix();
      loadmatrix(Ident);
      c3f(whitevec);
      cmov(-0.6,-0.4,-0.5);
      fmprstr(str);
      popmatrix();

      getmatrix(M1);
      numpatches = cnt;
      lmbind(MATERIAL, 1);
      for(i = 0; i < cnt; i++)
      {
	if (0/*multi_color*/) {
	  colr_ind = i%17 + 1;
	  if (colr_ind == 9 || colr_ind == 11) colr_ind++;
	  lmbind(MATERIAL, colr_ind); 
        }

	patchno = i;
	if(i >= MAX_PATCH_GP) continue;
	
	if(all) {nusteps = nvsteps = nsteps;}
	
	insteps[0][0] = insteps[0][1] = insteps[1][0] = insteps[1][1] = 0;
	
	if (i == num_of_first_patch) { 
	  if (num_of_second_patch) pushmatrix();
	  if (0/*separate*/) loadmatrix(Mp);
	  getmatrix(M1);
	  if (!multi_color) lmbind(MATERIAL, 2); 
	}
	
	for(j=0; j<=udegree[i]; j++)
	  for(k=0; k<=vdegree[i]; k++)
	    for(l=0; l<WCOORD; l++)
	      cntrlp1[j][k][l] = cntrl[i][j][k][l];
	for (j=0; j<ncurves[i]; j++)
	  pcurve[j] = &curve[i][j][0];
	
	bez_surface(cntrlp1, (byte)udegree[i], (byte)vdegree[i], dglob,
		    pcurve, ncurves[i], cdegree[i], -1, NULL);
      }
      if (autom) swapbuffers();
      if (num_of_second_patch) popmatrix();
   }
}

void draw_xyz_point(x, y, z, dr)
double x, y, z;
int dr;
{
    intpoints[ip][0]=x - dispx;
    intpoints[ip][1]=y - dispy;
    intpoints[ip][2]=z - dispz;
    ip++;
     /* if (dr) draw_int_patch(); */
    if (dr) draw_patch_xyz(0); 
}

int s0,s1,c0,c1 ;
set_int_patch(i,j,col1,col2)
int i, j, col1, col2;
{
  s0 = i;
  s1 = j;
  c0 = col1;
  c1 = col2 ;
}

draw_patch_xyz(tog)
int tog;
{
    WTYPE cntrlp1[MAX_DEGREE][MAX_DEGREE][WCOORD];
    WTYPE divparam;
    DlistGlobalsType *dglob;
    int i, j, k, l, insteps[2][2], c_ind;
    char ch;
    Matrix Tmp;

    divparam = DIVPARAM;
    curvparam = CURVPARAM;
    tolerance = TOLERANCE;

   if (tog) {   
    lmbind(MATERIAL, 1);
/*
    pushmatrix();
    getmatrix(Tmp);
    loadmatrix(pMmpi);
    multmatrix(Tmp);
*/
    if (sp) {
      pushmatrix();
      multmatrix(Mmpi);
    }

   if (!curve_or_full) {
    for (i=0; i<numpatches; i++) {
      if (multi_color) {
	c_ind = i%17 + 1;
	if (c_ind == 9 || c_ind == 11) c_ind++;
	lmbind(MATERIAL, c_ind);
      }
      patchno = i;
      insteps[0][0] = insteps[0][1] = 
	insteps[1][0] = insteps[1][1] = 0;
      
      if (i == num_of_first_patch) { 
	if (sp) popmatrix(); 
	if (!multi_color) lmbind(MATERIAL, 2); 
      }
      
      for(j=0; j<=udegree[i]; j++)
	for(k=0; k<=vdegree[i]; k++)
	  for(l=0; l<WCOORD; l++)
	    cntrlp1[j][k][l] = cntrl[i][j][k][l];
      
      for (j=0; j<ncurves[i]; j++)
	pcurve[j] = &curve[i][j][0];
      
      bez_surface(cntrlp1, (byte)udegree[i], (byte)vdegree[i], dglob,
		  pcurve, ncurves[i], cdegree[i], -1, NULL);
    }
   } else
	if (sp) popmatrix();
    /* popmatrix(); */
  }

    /* lmbind(MATERIAL, 13); */
    lmbind(MATERIAL, 9);
    for (i=0; i<ip; i++) {
      sphere[0]=intpoints[i][0];
      sphere[1]=intpoints[i][1];
      sphere[2]=intpoints[i][2];
      sphere[3]=Sphradius;
      sphdraw( sphere );
    }
  
      swapbuffers();
}

draw_int_patch()
{
    WTYPE cntrlp1[MAX_DEGREE][MAX_DEGREE][WCOORD];
    WTYPE divparam;
    DlistGlobalsType *dglob;
    int i, j, k, l, insteps[2][2];
    char ch;

    divparam = DIVPARAM;
    curvparam = CURVPARAM;
    tolerance = TOLERANCE;
    c3f(purplevec);
    clear();
    zclear();
    lmbind(MATERIAL, 1);
   if (!curve_or_full) {
     /* for (i=0; i<numpatches; i++) { */
         patchno = s0;
         insteps[0][0] = insteps[0][1] = 
	 insteps[1][0] = insteps[1][1] = 0;

/*
	 if (i >= num_of_first_patch) lmbind(MATERIAL, 2);
         else lmbind(MATERIAL, 1);
	 if (i == s0) lmbind(MATERIAL, c0); 
	 if (i == s1) lmbind(MATERIAL, c1); 
*/

         for(j=0; j<=udegree[s0]; j++)
          for(k=0; k<=vdegree[s0]; k++)
           for(l=0; l<WCOORD; l++)
             cntrlp1[j][k][l] = cntrl[s0][j][k][l];

         bez_surface(cntrlp1, udegree[s0], vdegree[s0], 
		     1, insteps, 0, 0, 0, 0, tolerance, 
		     curvparam, divparam, 0, 0, dglob);
     /* } */

	 lmbind(MATERIAL, 2);
         patchno = s1;
         insteps[0][0] = insteps[0][1] = 
	 insteps[1][0] = insteps[1][1] = 0;

/*
	 if (i >= num_of_first_patch) lmbind(MATERIAL, 2);
         else lmbind(MATERIAL, 1);
	 if (i == s0) lmbind(MATERIAL, c0); 
	 if (i == s1) lmbind(MATERIAL, c1); 
*/

         for(j=0; j<=udegree[s1]; j++)
          for(k=0; k<=vdegree[s1]; k++)
           for(l=0; l<WCOORD; l++)
             cntrlp1[j][k][l] = cntrl[s1][j][k][l];

         bez_surface(cntrlp1, udegree[s1], vdegree[s1], 
		     1, insteps, 0, 0, 0, 0, tolerance, 
		     curvparam, divparam, 0, 0, dglob);
   }

    /* lmbind(MATERIAL, 13); */
    lmbind(MATERIAL, 9);
    for (i=0; i<ip; i++) {
      sphere[0]=intpoints[i][0];
      sphere[1]=intpoints[i][1];
      sphere[2]=intpoints[i][2];
      sphere[3]=Sphradius;
      sphdraw( sphere );
    }
    swapbuffers();
}


input_and_loop() 
{
int i;

   if (sp) loadmatrix(Mp);
   while (1) {
     if (getinput() == 99) break;
     c3f(purplevec);
     clear();
     zclear();
   /* changed_patch = Compute = 1; */
   for(i=0; i<numpatches; i++)
      patchinit[i] = 0;
     draw_patch_xyz(1);
      /* draw_int_patch(); */
   }
}

/*
render_wire(render, n1, v1, n2, v2, n3, v3, dglob)
int render;
VECTOR n1, n2, n3;
POINT v1, v2, v3;
DlistGlobalsType *dglob;
{
   if(render) return;
   bgnline();
	n3t(n1);
	v3t(v1);
	n3t(n2);
	v3t(v2);
	n3t(n3);
	v3t(v3);
   endline();
}
*/
render_wire(render, v1, v2, v3, dglob)
int render;
/* VECTOR n1, n2, n3; */
VERTEX *v1, *v2, *v3;
DlistGlobalsType *dglob;
{
   if(render) return;
   bgnline();
        n3t(v1->n);
        v3t(v1->p);
        n3t(v2->n);
        v3t(v2->p);
        n3t(v3->n);
        v3t(v3->p);
        n3t(v1->n);
        v3t(v1->p);
   endline();
}

render_Trio(render, n1, v1, n2, v2, n3, v3, dglob)
int render;
VECTOR n1, n2, n3;
POINT v1, v2, v3;
DlistGlobalsType *dglob;
{
int i, index;

/* //
   if(render) return;
global = global+1;
/* */
   if(!render){
   bgnpolygon();
        n3t(n1);
        v3t(v1);
        n3t(n2);
        v3t(v2);
        n3t(n3);
        v3t(v3);
   endpolygon();}
/* */

   index = tindex[patchno];

  if(render)
   {
      for(i=0; i<index; i++) {
      bgnpolygon();
        n3t(keep[patchno][i][0][0]);
        v3t(keep[patchno][i][0][1]);
        n3t(keep[patchno][i][1][0]);
        v3t(keep[patchno][i][1][1]);
        n3t(keep[patchno][i][2][0]);
        v3t(keep[patchno][i][2][1]);
      endpolygon();}
      return;
   }
     keep[patchno][index][0][0][0] = n1[0];
     keep[patchno][index][0][0][1] = n1[1];
     keep[patchno][index][0][0][2] = n1[2];
     keep[patchno][index][0][1][0] = v1[0];
     keep[patchno][index][0][1][1] = v1[1];
     keep[patchno][index][0][1][2] = v1[2];

     keep[patchno][index][1][0][0] = n2[0];
     keep[patchno][index][1][0][1] = n2[1];
     keep[patchno][index][1][0][2] = n2[2];
     keep[patchno][index][1][1][0] = v2[0];
     keep[patchno][index][1][1][1] = v2[1];
     keep[patchno][index][1][1][2] = v2[2];

     keep[patchno][index][2][0][0] = n3[0];
     keep[patchno][index][2][0][1] = n3[1];
     keep[patchno][index][2][0][2] = n3[2];
     keep[patchno][index][2][1][0] = v3[0];
     keep[patchno][index][2][1][1] = v3[1];
     keep[patchno][index][2][1][2] = v3[2];

     (tindex[patchno])++;
}

/*
render_Tri(render, n1, v1, n2, v2, n3, v3, dglob)
int render;
VECTOR n1, n2, n3;
POINT v1, v2, v3;
DlistGlobalsType *dglob;
{
 VECTOR nn1, nn2, nn3;
 int i;

 for (i=0; i<WCOORD; i++) {
    nn1[i] = -n1[i] ;
    nn2[i] = -n2[i] ;
    nn3[i] = -n3[i] ;
 }
   if(render) return;
   bgnpolygon();
	n3t(n1);
	v3t(v1);
	n3t(n2);
	v3t(v2);
	n3t(n3);
	v3t(v3);
   endpolygon();
}
*/

render_Tris(render, v1, v2, v3, dglob)
int render;
VERTEX *v1, *v2, *v3;
DlistGlobalsType *dglob;
{
/* return; */
if(fill) render_Tri(render, v1, v2, v3, dglob);
else     render_wire(render, v1, v2, v3, dglob);
/* render_Tri(n1, v1, n2, v2, n3, v3, dglob); */
}

render_Tri(render, v1, v2, v3, dglob)
int render;
VERTEX *v1, *v2, *v3;
DlistGlobalsType *dglob;
{
   if(render) return;
/* WHAT IS THIS ?
   v1->n[X] = v1->n[X]; v1.n[Y] = v1.n[Y]; v1.n[Z] = v1.n[Z];
   v2->n[X] = v2->n[X]; v2.n[Y] = v2.n[Y]; v2.n[Z] = v2.n[Z];
   v3->n[X] = v3->n[X]; v3.n[Y] = v3.n[Y]; v3.n[Z] = v3.n[Z];
*/
   bgnpolygon();
        n3t(v1->n);
        v3t(v1->p);
        n3t(v2->n);
        v3t(v2->p);
        n3t(v3->n);
        v3t(v3->p);
   endpolygon();
}

render_tri(render, n1, v1, n2, v2, n3, v3, dglob)
int render;
VECTOR n1, n2, n3;
POINT v1, v2, v3;
DlistGlobalsType *dglob;
{
/* return; */
if(fill) render_Tri(render, n1, v1, n2, v2, n3, v3, dglob);
else     render_wire(render, n1, v1, n2, v2, n3, v3, dglob);
/* render_Tri(n1, v1, n2, v2, n3, v3, dglob); */
}

int loadmodel(filename)
char filename[];
{
int i, j, k, cnt, gpno, gpcnt, udegree, vdegree;
FILE *fp;

   if(filename[0] == 0)
      strcpy(filename, "/afs/cs.unc.edu/home/kumar/surface/bezs/data.bez");
   fp = fopen(filename, "r");
   if(fp == NULL)
   {
      perror(filename);
      return 0;
   }
   cnt = gpno = gpcnt = 0;
}
#endif
