#include <sys/time.h>

typedef unsigned         TimerType;              /* Hardware Clock */

#ifndef ONYX
#define ONYX
#endif

#ifdef ONYX
#define GetTimer         *(iotimer_addr + 1)
#else
#define GetTimer         *(iotimer_addr)
#endif

#define MAXUNSIGNED      4294967295
extern  unsigned         *iotimer_addr;
extern  unsigned         Cycleval;

/* t2 & t1 must be unsigned for this to work .. */
#define TIMEDIFF(t2, t1) ( (t1 > t2)?   \
                           ( (double)(MAXUNSIGNED-t1+t2) /1.0e6*Cycleval) : \
                           ( (double)(t2-t1) /1.0e6*Cycleval) )
#define PRINTTIME(S,T)   printf("%s Time is %g us\n", S, T);

extern void InitCounter();
