#include <stdio.h>
#include <defs.h>

void usage()
{
  printf("usage: boole operator operand1 operand2 outputfile\n");
  printf("where operator is union, intersection, or difference\n");
  exit(1);
  return;
}

int main(int argc, char** argv)
{
  TRIM_PATCH_INFO* op1;
  TRIM_PATCH_INFO* op2;
  TRIM_PATCH_INFO* out;
  int op1_n, op2_n, out_n;
  int operator;
  FILE* fp1;
  FILE* fp2;
  FILE* fp3;

  if (argc != 5)
    usage();

  switch(argv[1][0]) {
  case 'u':
    operator = 1;
    break;
  case 'i':
    operator = 2;
    break;
  case 'd':
    operator = 3;
    break;
  default:
    usage();
  }

  fp1 = fopen(argv[2], "r");
  if (fp1 == NULL) { printf("Couldn't open %s\n", argv[2]); exit(1); }
  op1_n = read_solid_culver(fp1, &op1);  /* in parse/io.c */
  fclose(fp1);

  fp2 = fopen(argv[3], "r");
  if (fp2 == NULL) { printf("Couldn't open %s\n", argv[3]); exit(2); }
  op2_n = read_solid_culver(fp2, &op2);
  fclose(fp2);
  
  operate(&op1, op1_n, &op2, op2_n, operator,
	  &out, &out_n, 0.03);

  fp3 = fopen(argv[4], "w");
  if (fp3 == NULL) { printf("Couldn't open %s\n", argv[4]); exit(2); }
  write_solid_tagged(out, out_n, fp3);
  fclose(fp3);

  return (0);
}
