#include <stdio.h>
#include <defs.h>
int main(int argc, char** argv) {
  FILE* fpin;
  FILE* fpout;
  TRIM_PATCH_INFO* solid;
  int n, rv;
  
  if (argc != 3) {
    printf("usage: tag <in> <out>\n");
    printf("       Convert from old Boole format to tagged Boole format.\n");
    return 1;
  }
  argv++;
  fpin = fopen(*argv, "r");
  argv++;
  fpout = fopen(*argv, "w");

  solid = (TRIM_PATCH_INFO*)malloc(MAX_PATCHES_PER_SOLID*sizeof(TRIM_PATCH_INFO));
  
  n = read_solid_culver(fpin, solid);
  printf("Read %d patches\n", n);
  rv = write_solid_tagged(solid, n, fpout);
  printf(rv ? "Wrote successfully\n" : "Write error\n");
  fclose(fpin);
  fclose(fpout);
  return 0;
}
