#ifndef PXPL
#include "sgi.h"
#endif

extern int  ros_gpnum; /* Std. PPhigs stuff */

/* tri.c -- gpstub */
#ifdef DEFINEVARS

#ifdef SGI
WTYPE fov, tanxy;
WTYPE diffnorm3();
int newin[4];
int donew = 0;
#endif

int      wire = 0;
int      bezdebug = 0;
int      patchno, arbit = 0;
int      changed_patch = 0;
int      gcoord = 4;
int      simple = 0;
int      Compute = 1;
int      Computebounds = 1;
byte     patchinit[NUMCACH];
int      tindex[MAX_PATCH_GP];
int      tottri = 0;
int      pdiff;
int      inverttri = 0;
int      Maxmem = 0;
int      faceflag = 0;
byte     in[MAX_PATCH_GP];

#ifdef PXPL
ElementHeader      LastElt;
TriangleRecord    *Ptris;
#ifdef STATICMEM
        /* TriangleRecord P[NUMCACH][MAX_TRI]; */
TriangleRecord (*P)[MAX_TRI];
#else /* NOT STATICMEM */
TriangleRecord *P[MAX_PATCH_GP];
#endif /* STATICMEM */
int             max_tri;
#else /* NOT PXPL */
BezEnvType       BezEnv;
#endif /* PXPL */

#else /* DEFINEVARS */

#ifdef SGI
extern WTYPE fov, tanxy;
extern WTYPE diffnorm3();
extern int newin[4];
extern int donew;
#endif

extern int      wire;
extern int      bezdebug;
extern int      patchno, arbit;
extern int      changed_patch;
extern int      gcoord;
extern int      simple;
extern int      Compute;
extern int      Computebounds;
extern byte     patchinit[NUMCACH];
extern int      tindex[MAX_PATCH_GP];
extern int      tottri;
extern int      pdiff;
extern int      inverttri;
extern int      Maxmem;
extern int      faceflag;
extern byte     in[MAX_PATCH_GP];

#ifdef PXPL
extern ElementHeader      LastElt;
extern TriangleRecord    *Ptris;
#ifdef STATICMEM
extern TriangleRecord (*P)[MAX_TRI];
#else /* NOT STATICMEM */
extern TriangleRecord *P[MAX_PATCH_GP];
#endif /* STATICMEM */
extern int             max_tri;
#else /* NOT PXPL */
extern BezEnvType       BezEnv;
#endif /* PXPL */

#endif /* DEFINEVARS */

/* tri.c -- trim.c */
#ifdef TRIM_C

#define MAX_CROSS       10 /* Max # curves crossing a v/u isoline */
#define STORED          -1
#define STOREDL         -1
#define STOREDR         -2
#define CONTAINED       -3
#define F_DELTA		1.0e-5 /* 0.00001 */

#ifdef DEFINEVARS
/* struct   crosstype cross[MAX_NO_POINTS2][MAX_NO_POINTS2]; */
/* int    holeu, holev; */
/* TPOINT *holecrit, *holecritend; */
short   cross[MAX_NO_POINTS][MAX_CROSS];
int    minvnum, maxvnum;
#else /* DEFINEVARS */
/* extern struct   crosstype cross[MAX_NO_POINTS2][MAX_NO_POINTS2]; */
/* extern int holeu, holev; */
/* extern TPOINT *holecrit, *holecritend; */
extern short   cross[MAX_NO_POINTS][MAX_CROSS];
extern int    minvnum, maxvnum;

#endif /* DEFINEVARS */

#endif /* TRIM_C */
