/* DEMOABLE */
/* The viewing plane is at hither here */
/* Rockwood's + Curvature + Subdivision of patches */
/* #define SGI */

#include "color.h"

#ifdef SGI
#define print if(0) printf
extern WTYPE fov, tanxy;
extern WTYPE diffnorm3();
#define GP	0
#else
WTYPE fov;
#define GP	9
/* #define print if(rc_refine_pass() == 1) printf */
#define print if(rc_refine_pass() == 1 && ros_gpnum == GP) printf
#define print if(0) printf
#define Printf if(rc_refine_pass() == 1 && debug) printf
#define CPrintf if(rc_refine_pass() == 1 && cdebug == 1) printf
#endif

#define NUMCACH		MAX_PATCH_GP

/*
WTYPE caux1[NUMCACH][MAX_NO_POINTS+2][MAX_NO_POINTS+2][WCOORD];
WTYPE caux2[NUMCACH][MAX_NO_POINTS+2][MAX_NO_POINTS+2][WCOORD];
WTYPE ccurvpt[NUMCACH][2][MAX_NO_POINTS+2][WCOORD];
WTYPE ccurvn1[NUMCACH][2][MAX_NO_POINTS+2][WCOORD];
*/
WTYPE (*caux1)[MAX_NO_POINTS2][MAX_NO_POINTS2][WCOORD];
WTYPE (*caux2)[MAX_NO_POINTS2][MAX_NO_POINTS2][WCOORD];
WTYPE (*ccurvpt)[2][MAX_NO_POINTS2][WCOORD];
WTYPE (*ccurvn1)[2][MAX_NO_POINTS2][WCOORD];
int   in, init[NUMCACH], num_cache_points;
static int   curvadd[MAX_PATCH_GP][2][2];

extern WTYPE diffnorm();
/*
#ifdef PXPL
TimerValue timep1, timep2;
#define STARTTIME if(rc_refine_pass() == 1 && ros_gpnum == GP) read_timer(&timep1);
#define ENDTIME(x) if(rc_refine_pass() == 1 && ros_gpnum == GP){		\
		   read_timer(&timep2);					\
		   CPrintf("%s:", x);                                    \
	           CPrintf("Time at gp(patch)-pass %d(%d)-%d = %g\n",	\
                   ros_gpnum, patchno, rc_refine_pass(),		\
                   timer_to_double(&timep2)-timer_to_double(&timep1));}
#else
#ifdef SGIUNDEF
struct timeval timep1, timep2;
struct timezone TimeZone;
#define STARTTIME if(patchno == 16) gettimeofday(&timep1, &TimeZone);
#define ENDTIME(x) if(patchno == 16){					\
		   gettimeofday(&timep2, &TimeZone);			\
		   CPrintf("%s: Time for gp(patch)-pass %d(%d)-%d = ",   \
		   x, ros_gpnum, patchno, 1);				       \
   		   if (timep1.tv_usec > timep2.tv_usec)			       \
		   {							       \
		    CPrint("%d\n", (timep2.tv_sec-timep1.tv_sec-1)*1000000 +   \
                    (timep2.tv_usec-timep1.tv_usec+1000000)); 	               \
		   }							       \
		   else							       \
		   {							       \
		    CPrint("%d\n", (timep2.tv_sec-timep1.tv_sec)*1000000 +     \
                              (timep2.tv_usec-timep1.tv_usec));       	       \
		   }}
#else
#define	STARTTIME
#define	ENDTIME(x)
#endif
#endif
*/
extern int freeze, subdiv, debug, cdebug;
extern int ros_gpnum;
extern int hNSTEPS, hLSTEPS;
extern WTYPE hDIVPARAM, hCURVPARAM, hTOLERANCE;

extern int patchno, numpatches, arbit;
int statcolor = 61;

bez_pt(cntrl, degree, t, xyz_pt, coord)
WTYPE t, cntrl[][WCOORD];
POINT xyz_pt;
int degree, coord;
{
WTYPE s, t_i=1.0;
int i, j, Nci=1;

   s = 1-t;
   for(i=0; i<coord; i++)
      xyz_pt[i] = cntrl[0][i]*s;

   for(i=1; i<degree; i++)
   {
      t_i *= t;
      Nci = (Nci*(degree-i+1))/i;
      for(j=0; j<coord; j++)
         xyz_pt[j] = (xyz_pt[j] + t_i*Nci*cntrl[i][j])*s;
   }
   for(j=0; j<coord; j++)
      xyz_pt[j] += t_i*t*cntrl[degree][j];
}

bez_curve(cntrl, degree, nsteps, ptlist, luv, ruv, coord)
WTYPE cntrl[][WCOORD];
WTYPE ptlist[][WCOORD];
WTYPE luv, ruv;
int degree, nsteps, coord;
{
int i;
WTYPE step, u;
POINT lastpt, pt;

   step = (ruv-luv)/(WTYPE)nsteps;
   u = luv;
   for(i=0; i<=nsteps; i++)
   {
      bez_pt(cntrl, degree, u, ptlist[i], coord);
      u += step;
   }
}

Bez_surface(cntrl, udegree, vdegree, nusteps, nvsteps, insteps, udepth, vdepth,
	    upath, vpath, dglob, coord, corners, cut, tolerance)
WTYPE cntrl[][MAX_DEGREE][WCOORD], tolerance;
int udegree, vdegree, nvsteps, nusteps, insteps[][2], coord;
int   corners, cut, udepth, vdepth, upath, vpath;
DlistGlobalsType *dglob;
{
int   calc, nsteps,tnsteps, i, j, k, l, m;
int   ucurvcnt, basecurvcnt, basevcurvcnt[2], vcurvcnt[2], alt0, alt1;
int   linsteps[2][2];
WTYPE zero = 0; /* Declaring as int has wrong vcurve[1] */
static int   sinsteps[NUMCACH][2][2];
static int   rsinsteps[NUMCACH][2][2];
/* */
WTYPE (*aux1)[MAX_NO_POINTS+2][WCOORD];
WTYPE (*aux2)[MAX_NO_POINTS+2][WCOORD];
WTYPE (*curvpt)[MAX_NO_POINTS+2][WCOORD];
WTYPE (*curvn1)[MAX_NO_POINTS+2][WCOORD];
/* //
WTYPE aux1[2][MAX_NO_POINTS+2][WCOORD];
WTYPE aux2[2][MAX_NO_POINTS+2][WCOORD];
WTYPE curvpt[2][MAX_NO_POINTS+2][WCOORD];
WTYPE curvn1[2][MAX_NO_POINTS+2][WCOORD];
/* */
WTYPE cntrl2[MAX_DEGREE][MAX_DEGREE][WCOORD];
WTYPE cntrl3[MAX_DEGREE][MAX_DEGREE][WCOORD];
WTYPE u, v, ucurve, vcurve[2], ustepsize, vstepsize, stepsize[2][2];
WTYPE lu, ru, ulen, vlen, utolerance, vtolerance, tmp1, tmp2;
WTYPE lastv[2], u0[2], u1[2];
POINT t1, t2;
/* WTYPE zero = 0.0; Compiler bug - Option -O -sched.. See MARK */

/*
          insteps[0][0] < sinsteps[patchno][0][0] -EXTRAPTS-EXTRAPTS ||
          insteps[0][0] > sinsteps[patchno][0][0] ||
          insteps[1][1] < sinsteps[patchno][0][1] -EXTRAPTS-EXTRAPTS ||
          insteps[0][1] > sinsteps[patchno][0][1] ||
          insteps[0][1] < sinsteps[patchno][1][1] -EXTRAPTS-EXTRAPTS ||
          insteps[1][0] > sinsteps[patchno][1][0] ||
          insteps[1][0] < sinsteps[patchno][1][1] -EXTRAPTS-EXTRAPTS ||
          insteps[1][1] > sinsteps[patchno][1][1] )
       else
       {
          calc = 0;
          insteps[0][0] = sinsteps[patchno][0][0];
          insteps[0][1] = sinsteps[patchno][0][1];
          insteps[1][0] = sinsteps[patchno][1][0];
          insteps[1][1] = sinsteps[patchno][1][1];
       }
*/

    calc = 0;
    if(freeze)
    {
          printf("Frozen\n");
          insteps[0][0] = sinsteps[patchno][0][0];
          insteps[0][1] = sinsteps[patchno][0][1];
          insteps[1][0] = sinsteps[patchno][1][0];
          insteps[1][1] = sinsteps[patchno][1][1];
    } else
    if(patchno < NUMCACH)
    {
       if(!init[patchno])
       {
          sinsteps[patchno][0][0] = -1;
          sinsteps[patchno][0][1] = -1;
          sinsteps[patchno][1][0] = -1;
          sinsteps[patchno][1][1] = -1;
          init[patchno] = 1;
       }
       if(/*!init[patchno] ||*/
          insteps[0][0] < sinsteps[patchno][0][0] -EXTRAPTS-EXTRAPTS ||
          insteps[0][0] > sinsteps[patchno][0][0])
       {
          i = 1<<udepth;
          j = EXTRAPTS+insteps[0][0];
          /* if(j&1) j += 1; */
          if(j/i >= MAX_NO_POINTS-1) j = insteps[0][0];
          sinsteps[patchno][0][0]=insteps[0][0] = j;
          calc = 1;
       }
       else
          insteps[0][0] = sinsteps[patchno][0][0];

       if(/*!init[patchno] ||*/
          insteps[0][1] < sinsteps[patchno][0][1] -EXTRAPTS-EXTRAPTS ||
          insteps[0][1] > sinsteps[patchno][0][1])
       {
          i = 1<<udepth;
          j = EXTRAPTS+insteps[0][1];
          /* if(j&1) j += 1; */
          if(j/i >= MAX_NO_POINTS-1) j = insteps[0][1];
          sinsteps[patchno][0][1]=insteps[0][1] = j;
          calc = 1;
       }
       else
          insteps[0][1] = sinsteps[patchno][0][1];

       if(/*!init[patchno] ||*/
          insteps[1][0] < sinsteps[patchno][1][0] -EXTRAPTS-EXTRAPTS ||
          insteps[1][0] > sinsteps[patchno][1][0])
       {
          i = 1<<vdepth;
          j = EXTRAPTS+insteps[1][0];
          /* if(j&1) j += 1; */
          if(j/i >= MAX_NO_POINTS-1) j = insteps[1][0];
          sinsteps[patchno][1][0]=insteps[1][0] = j;
          calc = 1;
       }
       else
          insteps[1][0] = sinsteps[patchno][1][0];

       if(/*!init[patchno] ||*/
          insteps[1][1] < sinsteps[patchno][1][1] -EXTRAPTS-EXTRAPTS ||
          insteps[1][1] > sinsteps[patchno][1][1])
       {
          i = 1<<vdepth;
          j = EXTRAPTS+insteps[1][1];
          /* if(j&1) j += 1; */
          if(j/i >= MAX_NO_POINTS-1) j = insteps[1][1];
          sinsteps[patchno][1][1]=insteps[1][1] = j;

          init[patchno] = 1; calc = 1;
       }
       else
          insteps[1][1] = sinsteps[patchno][1][1];
    }


      CPrintf("in%d/%d(%d): insteps = %d %d %d %d\n",in, ros_gpnum, patchno,
             insteps[0][0], insteps[0][1], insteps[1][0], insteps[1][1]);

    if(!in) return;
    if(!calc &&
    (rsinsteps[patchno][0][0] != sinsteps[patchno][0][0] ||
     rsinsteps[patchno][0][1] != sinsteps[patchno][0][1] ||
     rsinsteps[patchno][1][0] != sinsteps[patchno][1][0] ||
     rsinsteps[patchno][1][1] != sinsteps[patchno][1][1] ))
       calc = 1;
    rsinsteps[patchno][0][0] = sinsteps[patchno][0][0];
    rsinsteps[patchno][0][1] = sinsteps[patchno][0][1];
    rsinsteps[patchno][1][0] = sinsteps[patchno][1][0];
    rsinsteps[patchno][1][1] = sinsteps[patchno][1][1];

   if(arbit == -1) calc = 1;

   if(ros_gpnum == GP && calc) print("calc = %d\n", calc);
    /* calc = 1; */

/* */
   aux1 = caux1[patchno]; aux2 = caux2[patchno];
   curvpt = ccurvpt[patchno]; curvn1 = ccurvn1[patchno];
/* */

   Printf("coord = %d\n", coord);
   Printf("OK, in Bez_surface\n");
   /* Printf("Bez: steps: %d, %d, %d\n", nusteps, nvsteps, nsteps); */

   i = 1<<udepth; j = i-1;
   k = (insteps[0][0] * upath + j)/i;
   l = (insteps[0][0] * (upath+1) + j)/i;
   linsteps[0][0] = l-k;
   stepsize[0][0] = (1.0)/insteps[0][0]*i;
   if(k == 0 && insteps[0][0] == 0) u0[1] = 0.0;
   else u0[0] = (k/(WTYPE)insteps[0][0] - upath/(WTYPE)i)*(WTYPE)i;
   if(l == 0 && insteps[0][0] == 0) tmp1 = 1.0;
   else tmp1 = l/(WTYPE)insteps[0][0];
   u1[0] = FDELTA_1 + (tmp1 - (upath+1)/(WTYPE)i)*(WTYPE)i;

   k = (insteps[0][1] * upath + j)/i;
   l = (insteps[0][1] * (upath+1) + j)/i;
   linsteps[0][1] = l-k;
   stepsize[0][1] = (1.0)/insteps[0][1]*i;
   if(k == 0 && insteps[0][1] == 0) u0[1] = 0.0;
   else u0[1] = (k/(WTYPE)insteps[0][1] - upath/(WTYPE)i)*(WTYPE)i;
   if(l == 0 && insteps[0][1] == 0) tmp1 = 1.0;
   else tmp1 = l/(WTYPE)insteps[0][1];
   u1[1] = FDELTA_1 + (tmp1 - (upath+1)/(WTYPE)i)*(WTYPE)i;

   if(upath == 0)
   {/* Can save evaluation here. Taken up by curvpt */
      linsteps[0][0]--; linsteps[0][1]--;
      u0[0] += stepsize[0][0];
      u0[1] += stepsize[0][1];
   }
   if(upath == j)
   {
      linsteps[0][0]--; linsteps[0][1]--;
      u1[0] -= stepsize[0][0];
      u1[1] -= stepsize[0][1];
   }

   m = j; /* save j for checking last u div */
   i = 1<<vdepth; j = i-1;

   if(upath == 0)
   {
      k = (insteps[1][0] * vpath + j)/i;
      l = (insteps[1][0] * (vpath+1) + j)/i;
      linsteps[1][0] = l - k;
      stepsize[1][0] = (1.0)/insteps[1][0]*i;
      if(k == 0 && insteps[1][0] == 0) vcurve[0] = 0.0;
      else vcurve[0] = (k/(WTYPE)insteps[1][0] - vpath/(WTYPE)i)*(WTYPE)i;
      if(l == 0 && insteps[1][0] == 0) tmp1 = 1.0;
      else tmp1 = l/(WTYPE)insteps[1][0];
      lastv[0] = 1.0 + (tmp1 - (vpath+1)/(WTYPE)i)*(WTYPE)i;
      /* lastv[0] = FDELTA_1 + (tmp1 - (vpath+1)/(WTYPE)i)*(WTYPE)i; */
   } else
   {
      linsteps[1][0] = insteps[1][0] - 2;
      stepsize[1][0] = (1.0)/insteps[1][0]; /* Right #steps, no scaling */
      vcurve[0] = stepsize[1][0];
      lastv[0] = 1.0 - stepsize[1][0];
      /* lastv[0] = FDELTA_1 - stepsize[1][0]; */
   }

   if(upath == m)
   {
      k = (insteps[1][1] * vpath + j)/i;
      l = (insteps[1][1] * (vpath+1) + j)/i;
      linsteps[1][1] = l - k;
      stepsize[1][1] = (1.0)/insteps[1][1]*i;
      if(k == 0 && insteps[1][1] == 0) vcurve[1] = 0.0;
      else vcurve[1] = (k/(WTYPE)insteps[1][1] - vpath/(WTYPE)i)*(WTYPE)i;
      if(l == 0 && insteps[1][1] == 0) tmp1 = 1.0;
      else tmp1 = l/(WTYPE)insteps[1][1];
      lastv[1] = 1.0 + (tmp1 - (vpath+1)/(WTYPE)i)*(WTYPE)i;
      /* lastv[1] = FDELTA_1 + (tmp1 - (vpath+1)/(WTYPE)i)*(WTYPE)i; */
   } else
   {
      linsteps[1][1] = insteps[1][1] - 2;
      stepsize[1][1] = (1.0)/insteps[1][1];
      vcurve[1] = stepsize[1][1];
      lastv[1] = 1.0 - stepsize[1][1];
      /* lastv[1] = FDELTA_1 - stepsize[1][1]; */
   }

      nusteps=(linsteps[0][0]>linsteps[0][1])? linsteps[0][0]:linsteps[0][1];
      nvsteps=(linsteps[1][0]>linsteps[1][1])? linsteps[1][0]:linsteps[1][1];
/*
      if(!arbit){
      vcurve[0] -= stepsize[1][0]; vcurve[1] -= stepsize[1][1];
      }
*/
		/* To start Calculation at vcurve[0/1] */
                /*  In the new scheme, it starts correctly */

   if(nusteps < LSTEPS) nusteps = LSTEPS;
   if(nusteps >= MAX_NO_POINTS) nusteps = MAX_NO_POINTS-1;
   if(nusteps < LSTEPS) nusteps = LSTEPS;
   if(nvsteps >= MAX_NO_POINTS) nvsteps = MAX_NO_POINTS-3;
   if(nvsteps < LSTEPS) nvsteps = LSTEPS;
   /* if(linsteps[0][0] < NSTEPS) linsteps[0][0] = NSTEPS; */
   /* if(linsteps[0][0] >= MAX_NO_POINTS) linsteps[0][0] = MAX_NO_POINTS-1; */
   /* if(linsteps[0][1] < NSTEPS) linsteps[0][1] = NSTEPS; */
   /* if(linsteps[0][1] >= MAX_NO_POINTS) linsteps[0][1] = MAX_NO_POINTS-1; */
   /* if(linsteps[1][0] < NSTEPS) linsteps[1][0] = NSTEPS; */
   /* if(linsteps[1][0] >= MAX_NO_POINTS) linsteps[1][0] = MAX_NO_POINTS-1; */
   /* if(linsteps[1][1] < NSTEPS) linsteps[1][1] = NSTEPS; */
   /* if(linsteps[1][1] >= MAX_NO_POINTS) linsteps[1][1] = MAX_NO_POINTS-1; */
   utolerance = (1.0)/(nusteps+2);
   vtolerance = (1.0)/(nvsteps+2);
   /* tolerance = (tmp1 < tmp2)? tmp1:tmp2; */
   /* Printf("Bez: tolerance is %g\n", tolerance); */

   /* uvlen = 1-2*tolerance; */
   ulen = (1.0)-2*utolerance;
   vlen = (1.0)-2*vtolerance;
   vstepsize = vlen/(float)nvsteps;
   ustepsize = ulen/(float)nusteps;
   /* luv = tolerance; */
   /* ruv = 1-tolerance; */
   lu = utolerance;
   ru = 1.0 - utolerance;

   Printf("Bez on %d: u = %d,v = %d, n = %d %d %d %d\n", ros_gpnum,nusteps,nvsteps,
            linsteps[0][0], linsteps[0][1], linsteps[1][0], linsteps[1][1]);


   Printf("ulen = %g; vlen = %g\n", ulen, vlen);
   Printf("tolerance = %g %g\n", utolerance, vtolerance);

    alt0 = 0; alt1 = -1;
    /* alt0 = 0; alt1 = 1; */

/**/

   for(i=0; i<udegree; i++)
      for(j=0; j<=vdegree; j++)
      {
         for(k=0; k<WCOORD; k++)
            cntrl2[i][j][k] = cntrl[i+1][j][k]-cntrl[i][j][k];
      /* cntrl2[i][j][COORD] = 1.0; */
      }
   for(i=0; i<=udegree; i++)
      for(j=0; j<vdegree; j++)
      {
         for(k=0; k<WCOORD; k++)
            cntrl3[i][j][k] = cntrl[i][j+1][k]-cntrl[i][j][k];
         /* cntrl3[i][j][COORD] = 1.0; */
      }

   if(calc)
   {
      fillcurve0(cntrl, cntrl2, cntrl3, udegree, vdegree, linsteps[1][0],
      curvpt[0][1], curvn1[0][1], 0.0, vcurve[0], lastv[0], coord, U);

      fillcurve0(cntrl, cntrl2, cntrl3, udegree, vdegree, linsteps[1][1],
      curvpt[1][1], curvn1[1][1], 1.0, vcurve[1], lastv[1], coord, U);
   }

   v = 0.0;

/* BUGSY */

   /* nsteps = linsteps[1][0]; tnsteps = linsteps[1][1];  */

	 basevcurvcnt[0] = basevcurvcnt[1] = 0;
	 vcurvcnt[0] = vcurvcnt[1] = 0;
   for(k=0; k<= nvsteps+2; k++)
   {
      if((l = (k == nvsteps+2)) || k == 0)
      {
         nsteps = linsteps[0][l];

	 /* taylor */
         /* STARTTIME */
         if(calc)
            fillcurve(cntrl, cntrl2, cntrl3, udegree, vdegree, nsteps,
            aux2[alt0][l], aux1[alt0][l], v, u0[l], u1[l], coord);

         if(l)
	 {
            for(i=0; i<WCOORD; i++)
            {
	       aux2[alt0][0][i] = curvpt[0][vcurvcnt[0]][i];
	       aux1[alt0][0][i] = curvn1[0][vcurvcnt[0]][i];
	       aux2[alt0][nsteps+2][i] = curvpt[1][vcurvcnt[1]][i];
	       aux1[alt0][nsteps+2][i] = curvn1[1][vcurvcnt[1]][i];
	    }
	    linsteps[0][1] += 2;
            u0[1] -= stepsize[0][1]; u1[1] += stepsize[0][1];
	    /* Two extra points have been added at v = 1.0 */
	 }
	 else
            for(i=0; i<WCOORD; i++)
            {
	       curvpt[0][basevcurvcnt[0]][i] = aux2[alt0][0][i];
	       curvn1[0][basevcurvcnt[0]][i] = aux1[alt0][0][i];
	       curvpt[1][basevcurvcnt[1]][i] = aux2[alt0][nsteps][i];
	       curvn1[1][basevcurvcnt[1]][i] = aux1[alt0][nsteps][i];
	    }
      }
      else
      {
	 /* vcurvcnt[0] = vcurvcnt[1] = 0; */
	 /* Printf("vcurve[0/1]0 = %g %g, v = %g\n", vcurve[0],vcurve[1],v); */

      /*if(arbit)*/{
         while((vcurve[0] <= v) ||
            (k == nvsteps+1 && vcurvcnt[0] <= linsteps[1][0]))
            {
	       vcurve[0] += stepsize[1][0];
	       vcurvcnt[0]++;
            }
         while((vcurve[1] <= v) ||
            (k == nvsteps+1 && vcurvcnt[1] <= linsteps[1][1]))
            {
	       vcurve[1] += stepsize[1][1];
	       vcurvcnt[1]++;
            }
       }

         if(calc)
            fillcurve(cntrl, cntrl2, cntrl3, udegree,vdegree, nusteps,
                      aux2[alt0], aux1[alt0], v, lu, ru, coord);
      }

Printf("At v = %g:\n", v);
u = lu;
if(k > 0)
   if(k < nvsteps+2)
      nsteps = nusteps;
   else nsteps += 2;
/* for(i=0; i<=nsteps; i++) */
 {
  Printf("Calc:%g %g %g ## ", aux2[alt0][i][0],aux2[alt0][i][1],aux2[alt0][i][2]);
  /* bez_test(cntrl, udegree, vdegree, u, v, coord); */
  /* u += ustepsize; */
  }

      basecurvcnt = 0;
      u = lu;
      if(k == 1) ucurve = u0[0];
      else       ucurve = u0[1];
	/* Minus because real v = 1 curve points start at aux[alt1][1] */
      if(k == nvsteps+2)
          {i = alt0; alt0 = alt1; alt1 = i;}
          /* {alt0 = !alt0; alt1 = !alt1;} */
      if(k > 0)
      for(i=0; i<=nusteps; i++)
      {
         if((l = (k == nvsteps+2)) || k == 1)
	 {
            ucurvcnt = 0;
            while(ucurve <= u  || (i == nusteps && ucurve < u1[l]-FDELTA))
	    {
	       ucurve += stepsize[0][l];
	       if(basecurvcnt+ucurvcnt == linsteps[0][l])
		 continue;
	       ucurvcnt++;
	    }
            j = 0;
            if(i > 0)
            {
               if(k == 1)
	          for(j=basecurvcnt; j< basecurvcnt+ucurvcnt/2; j++)
	          {
	             render_tri(0, aux1[alt1][j], aux2[alt1][j],
                       aux1[alt1][j+1], aux2[alt1][j+1],
                       aux1[alt0][i-1], aux2[alt0][i-1],
                       dglob);
	          }
               else
	          for(j=basecurvcnt; j< basecurvcnt+ucurvcnt/2; j++)
	          {
	             render_tri(0, aux1[alt1][j], aux2[alt1][j],
		       aux1[alt0][i-1], aux2[alt0][i-1],
		       aux1[alt1][j+1], aux2[alt1][j+1],
		       dglob);
	          }

         /* if(i > 0) */
         /* if(j < basecurvcnt+ucurvcnt)  */
	       if(k == 1)
	       {
                  render_tri(0, aux1[alt0][i-1], aux2[alt0][i-1],
		       aux1[alt1][j], aux2[alt1][j],
                       aux1[alt0][i], aux2[alt0][i],
		       dglob);
   	       }
	       else
	       {
                  render_tri(0, aux1[alt0][i-1], aux2[alt0][i-1],
			aux1[alt0][i], aux2[alt0][i],
			aux1[alt1][j], aux2[alt1][j],
			dglob);
	       }
	    }
            if(k == 1)
	       for(; j<basecurvcnt+ucurvcnt; j++)
	       {
	          render_tri(0, aux1[alt1][j], aux2[alt1][j],
	               aux1[alt1][j+1], aux2[alt1][j+1],
	               aux1[alt0][i], aux2[alt0][i],
		       dglob);
	       }
            else
	       for(; j<basecurvcnt+ucurvcnt; j++)
	       {
	          render_tri(0, aux1[alt1][j], aux2[alt1][j],
    		       aux1[alt0][i], aux2[alt0][i],
		       aux1[alt1][j+1], aux2[alt1][j+1],
    		       dglob);
	       }
	    basecurvcnt += ucurvcnt;
	 }
         else if(k > 1 && i > 0)
         {
	    render_tri(0, aux1[alt1][i-1], aux2[alt1][i-1],
		    aux1[alt0][i], aux2[alt0][i],
		    aux1[alt0][i-1], aux2[alt0][i-1],
		    dglob);
	    render_tri(0, aux1[alt0][i], aux2[alt0][i],
		    aux1[alt1][i-1], aux2[alt1][i-1],
		    aux1[alt1][i], aux2[alt1][i],
		    dglob);
         }
         u += ustepsize;
      }


/* if(((arbit < 0) && (k == nvsteps+1)) || (k == arbit)) return; */

      if((l = (k == nvsteps+2)) || k == 1) tnsteps = linsteps[0][l];
      else			   tnsteps = nusteps;

      if(k > 0 && k < nvsteps+2)
      { /* The first one doesn't do any triangle */
	 for(j=basevcurvcnt[0]; j< vcurvcnt[0]/2; j++)
	    render_tri(0, curvn1[0][j], curvpt[0][j],
		       aux1[alt1][0], aux2[alt1][0],
		       curvn1[0][j+1], curvpt[0][j+1],
                       dglob);

        /* if(j < vcurvcnt[0])  */
        if(k > 0) 
	    render_tri(0, aux1[alt1][0], aux2[alt1][0],
                       aux1[alt0][0], aux2[alt0][0],
                       curvn1[0][j], curvpt[0][j],
		       dglob);

	 for(; j<vcurvcnt[0]; j++)
	    render_tri(0, curvn1[0][j], curvpt[0][j],
		       aux1[alt0][0], aux2[alt0][0],
		       curvn1[0][j+1], curvpt[0][j+1],
		       dglob);


	 /* for(j=0; j< vcurvcnt[1]/2; j++) */
	 for(j=basevcurvcnt[1]; j< vcurvcnt[1]/2; j++)
         {
	    render_tri(0, curvn1[1][j], curvpt[1][j],
		       curvn1[1][j+1], curvpt[1][j+1],
		       aux1[alt1][tnsteps], aux2[alt1][tnsteps],
                       dglob);
	 }
        /* if(j < vcurvcnt)  */
         if(k > 0)
         {
	    render_tri(0, aux1[alt1][tnsteps], aux2[alt1][tnsteps],
                       curvn1[1][j], curvpt[1][j],
                       aux1[alt0][nusteps], aux2[alt0][nusteps],
		       dglob);
	 }
	 for(; j<vcurvcnt[1]; j++)
         {
	    render_tri(0, curvn1[1][j], curvpt[1][j],
		       curvn1[1][j+1], curvpt[1][j+1],
		       aux1[alt0][nusteps], aux2[alt0][nusteps],
		       dglob);
	 }

         for(i=0; i<WCOORD; i++)
         {
            basevcurvcnt[0] = vcurvcnt[0];
            basevcurvcnt[1] = vcurvcnt[1];
         }
      }
/* if(((arbit < 0) && (k == nvsteps+1)) || (k == arbit)) return; */
/* if(k == 1) return; */

      if(k == 0 || k == nvsteps+1)
	v += vtolerance;
      else
	v += vstepsize;
       alt0 = (alt0 + 1) ; alt1 = (alt1+1);
       /* alt0 = !alt0; alt1 = !alt1; */
   }
   render_tri(1, curvn1[1][j], curvpt[1][j],
                       curvn1[1][j+1], curvpt[1][j+1],
                       aux1[alt0][nusteps], aux2[alt0][nusteps],
                       dglob);
}

bez_surface(cntrl, udegree, vdegree, first, insteps, udepth, vdepth, upath,
            vpath, tolerance, curvparam, divparam, corners, cut, dglob)
WTYPE cntrl[][MAX_DEGREE][WCOORD];
int   udegree, vdegree, first, corners, cut;
int   insteps[2][2], udepth, vdepth, upath, vpath;
WTYPE tolerance;
WTYPE curvparam;
WTYPE divparam;
DlistGlobalsType *dglob;
/* corner=0/2/4/8: uv=00/01/10/11 &&& cut=1 => division at v = ? / 0 => u = ? */

{
int linsteps[2][2];
int div, storeelt;
int corners1, cut1, corners2, cut2;
/* WTYPE (*cntrl2)[MAX_DEGREE][WCOORD]; */
WTYPE cntrl2[MAX_DEGREE][MAX_DEGREE][WCOORD];
WTYPE screentol;
/* int insteps[2][2]; /* 00: v=0 / 01: v=1 / 10: u=0 / 11: u=1 */
		   /* nusteps at v = 0,1 / nvsteps at u=0,1 */
int   nu, nv, uindx[MAX_DEGREE], vindx[MAX_DEGREE], keepnu[MAX_DEGREE];
int   keepnv[MAX_DEGREE];
WTYPE u[MAX_DEGREE], v[MAX_DEGREE];
WTYPE cntrlp[MAX_DEGREE*MAX_DEGREE][WCOORD], pt1[WCOORD];
/* WTYPE cntrlp2[MAX_DEGREE*MAX_DEGREE][WCOORD]; */
WTYPE cntrlp2[MAX_DEGREE][WCOORD];
WTYPE cntrlp1[MAX_DEGREE][MAX_DEGREE][WCOORD];
WTYPE tmp1, tmp2, area, invfovx, invfovy;
WTYPE lenv0, lenu0;
WTYPE bug;
WTYPE minwu[MAX_DEGREE], minwv[MAX_DEGREE], maxu[MAX_DEGREE], maxv[MAX_DEGREE];
int far, nohull, i, j, k, l;
int nusteps, nvsteps;
int coord;

   Printf("In bez_surface tolerance is %g\n", tolerance);
   Printf("In bez_surface divparam is %g\n", divparam);


   i = 1<<udepth;
   linsteps[0][0] = insteps[0][0]/i; /* approximately */
   linsteps[0][1] = insteps[0][1]/i;
   i = 1<<vdepth;
   linsteps[1][0] = insteps[1][0]/i; /* approximately */
   linsteps[1][1] = insteps[1][1]/i;

   /* tolerance = TOLERANCE; */
   divparam = hDIVPARAM;  /*  One hell of a hack to get around the optimizer bug */
   curvparam = hCURVPARAM;  /*  hell of a hack */
   screentol = hTOLERANCE;

   /* if(rc_refine_pass() == 1) */
   {
      Printf("First time = %d\n", first);
#ifdef SGI
      invfovy = tanxy;
      invfovx = tanxy;
#else
      fov = dglob->fdata.fov;
      invfovy = 1/dglob->fdata.fov;
      invfovx = 1/dglob->fdata.fov*1280/1024;
      /* invfovy = dglob->fdata.hither/dglob->fdata.fov; */
      /* invfovx = dglob->fdata.hither/dglob->fdata.fov*1280/1024; */
#endif

      /* minw = INFINITY; */
      /* maxu = maxv = -INFINITY; */
      for(j = 0; j <= udegree; j++)
      {
         minwv[j] = INFINITY;
         maxv[j] = -INFINITY;
      }
      for(k = 0; k <= vdegree; k++)
      {
         minwu[k] = INFINITY;
         maxu[k] = -INFINITY;
      }
      /* minwu0 = minwu1 = minwv0 = minwv1 = INFINITY; */
      /* maxu0 = maxv0 = maxu1 = maxv1 = -INFINITY; */
      coord = COORD;
      in = 0;
      for(l= 0,j = 0; j <= udegree; j++)
         for(k = 0; k <= vdegree; k++,l++)
         {
            if(cntrl[j][k][COORD] != 1) coord = WCOORD;
	    if(cntrl[j][k][COORD] < minwu[k]) minwu[k] = cntrl[j][k][COORD];
	    if(cntrl[j][k][COORD] < minwv[j]) minwv[j] = cntrl[j][k][COORD];

#ifdef SGI
            mymult(cntrl[j][k], pt1);
            far = 1;  /* pt1[2] < -hither; ? */
            /* far = pt1[2] > hither;  */
#else
            mymult(pt1, dglob->fdata.environ.eye_mat, cntrl[j][k], coord);
            far = pt1[2] > dglob->fdata.hither; /*DO IN OTHER VERSION ALSO*/ 
#endif

			/******/
            		/* cntrlp2[l][0] =  pt1[0]; */
            		/* cntrlp2[l][1] =  pt1[1]; */
            		/* cntrlp2[l][2] =  pt1[2];; */
			/******/
            cntrlp[l][0] =  pt1[0]/pt1[2];
            cntrlp[l][1] =  pt1[1]/pt1[2];
            cntrlp[l][2] =  1;


		/* Rockwood's tests */
	    if(j > 0)
	    {
		if((tmp1 = diffnorm(cntrlp[l], cntrlp[l-vdegree-1])) > maxu[k])
		   maxu[k] = tmp1;
	    }
	    if(k > 0)
	    {
		if((tmp1 = diffnorm(cntrlp[l], cntrlp[l-1])) > maxv[j])
		   maxv[j] = tmp1;
	    }

                 /* Clipped out ? */
            if(!in && far && cntrlp[l][0]<invfovx && cntrlp[l][0]>-invfovx &&
  	                  cntrlp[l][1]<invfovx && cntrlp[l][1]>-invfovx)
               in = 1;
Printf("Point %d: %g %g %g\n", l,cntrl[j][k][0],cntrl[j][k][1],cntrl[j][k][2]);
Printf("Result: %g %g %g\n", cntrlp[l][0],cntrlp[l][1],cntrlp[l][2]);
         }
      /* if(!in) return; */


      /* if(first) */
      if(!init[patchno])
      {
         /* cntrlp2 = &(cntrlp[MAX_DEGREE][0]); /* Space optimization */
         for(i=0; i<udegree; i++)
         {
            for(k=0; k<coord; k++)
            {
               cntrlp1[0][i][k] = cntrl[i+1][0][k]-cntrl[i][0][k];
               cntrlp1[1][i][k] = cntrl[i+1][vdegree][k]-cntrl[i][vdegree][k];
            }
         }
         bez_curve(cntrlp1[0], udegree-1, 1, cntrlp, 0.0, TOLERANCE, coord);
         if(coord == WCOORD)
         {
            for(i=0; i<=udegree; i++)
            {
               for(k=0; k<coord; k++)
                  cntrlp1[0][i][k] = cntrl[i][0][k];
            }
            bez_curve(cntrlp1[0], udegree, 1, cntrlp2, 0.0, TOLERANCE, coord);
            for(i=0; i<2; i++)
               for(j=0; j<COORD; j++)
               {
                  cntrlp2[i][j] /= cntrlp2[i][COORD];

	          cntrlp[i][j] = (cntrlp[i][j] - cntrlp2[i][j]*
                  cntrlp[i][COORD])/cntrlp2[i][COORD];
               }
         }
         tmp1 = (cntrlp[1][0]-cntrlp[0][0]); tmp2 = tmp1*tmp1;
         tmp1 = (cntrlp[1][1]-cntrlp[0][1]); tmp2 += tmp1*tmp1;
         tmp1 = (cntrlp[1][2]-cntrlp[0][2]); tmp2 += tmp1*tmp1;
         /* CPrintf("Curvature: %g\n", tmp2); */
         curvadd[patchno][0][0] = nusteps = SQRT(DOUBLE tmp2)*curvparam;

         bez_curve(cntrlp1[1], udegree-1, 1, cntrlp, 0.0, TOLERANCE, coord);
         if(coord == WCOORD)
         {
            for(i=0; i<=udegree; i++)
            {
               for(k=0; k<coord; k++)
                  cntrlp1[1][i][k] = cntrl[i][vdegree][k];
            }
            bez_curve(cntrlp1[1], udegree, 1, cntrlp2, 0.0, TOLERANCE, coord);
            for(i=0; i<2; i++)
               for(j=0; j<COORD; j++)
               {
                  cntrlp2[i][j] /= cntrlp2[i][COORD];

	          cntrlp[i][j] = (cntrlp[i][j] - cntrlp2[i][j]*
                  cntrlp[i][COORD])/cntrlp2[i][COORD];
               }
         }
         tmp1 = (cntrlp[1][0]-cntrlp[0][0]); tmp2 = tmp1*tmp1;
         tmp1 = (cntrlp[1][1]-cntrlp[0][1]); tmp2 += tmp1*tmp1;
         tmp1 = (cntrlp[1][2]-cntrlp[0][2]); tmp2 += tmp1*tmp1;
         /* CPrintf("Curvature: %g\n", tmp2); */
         curvadd[patchno][0][1] = nusteps = SQRT(DOUBLE tmp2)*curvparam;

         for(j=0; j<vdegree; j++)
         {
            for(k=0; k<coord; k++)
            {
               cntrlp1[0][j][k] = cntrl[0][j+1][k]-cntrl[0][j][k];
               cntrlp1[1][j][k] = cntrl[udegree][j+1][k]-cntrl[udegree][j][k];
            }
         }
         bez_curve(cntrlp1[0], vdegree-1, 1, cntrlp, 0.0, TOLERANCE, coord);
         if(coord == WCOORD)
         {
            bez_curve(cntrl[0], vdegree, 1, cntrlp2, 0.0, TOLERANCE, coord);
            for(i=0; i<2; i++)
               for(j=0; j<COORD; j++)
               {
                  cntrlp2[i][j] /= cntrlp2[i][COORD];

	          cntrlp[i][j] = (cntrlp[i][j] - cntrlp2[i][j]*
                  cntrlp[i][COORD])/cntrlp2[i][COORD];
               }
         }
         tmp1 = (cntrlp[1][0]-cntrlp[0][0]); tmp2 = tmp1*tmp1;
         tmp1 = (cntrlp[1][1]-cntrlp[0][1]); tmp2 += tmp1*tmp1;
         tmp1 = (cntrlp[1][2]-cntrlp[0][2]); tmp2 += tmp1*tmp1;
         /* CPrintf("Curvature: %g\n", tmp2); */
         curvadd[patchno][1][0] = nvsteps = SQRT(DOUBLE tmp2)*curvparam;


         bez_curve(cntrlp1[1], vdegree-1, 1, cntrlp, 0.0, TOLERANCE, coord);
         if(coord == WCOORD)
         {
            bez_curve(cntrl[udegree], vdegree, 1, cntrlp2, 0.0, TOLERANCE, coord);
            for(i=0; i<2; i++)
               for(j=0; j<COORD; j++)
               {
                  cntrlp2[i][j] /= cntrlp2[i][COORD];

	          cntrlp[i][j] = (cntrlp[i][j] - cntrlp2[i][j]*
                  cntrlp[i][COORD])/cntrlp2[i][COORD];
               }
         }

         tmp1 = (cntrlp[1][0]-cntrlp[0][0]); tmp2 = tmp1*tmp1;
         tmp1 = (cntrlp[1][1]-cntrlp[0][1]); tmp2 += tmp1*tmp1;
         tmp1 = (cntrlp[1][2]-cntrlp[0][2]); tmp2 += tmp1*tmp1;
         /* CPrintf("Curvature: %g\n", tmp2); */
         curvadd[patchno][1][1] = nvsteps = SQRT(DOUBLE tmp2)*curvparam;


         if(curvadd[patchno][0][0] > MAX_CURVATUR || curvadd[patchno][0][0] < 0)
            curvadd[patchno][0][0] = MAX_CURVATUR;
         if(curvadd[patchno][0][1] > MAX_CURVATUR || curvadd[patchno][0][1] < 0)
            curvadd[patchno][0][1] = MAX_CURVATUR;
         if(curvadd[patchno][1][0] > MAX_CURVATUR || curvadd[patchno][1][0] < 0)
            curvadd[patchno][1][0] = MAX_CURVATUR;
         if(curvadd[patchno][1][1] > MAX_CURVATUR || curvadd[patchno][1][1] < 0)
            curvadd[patchno][1][1] = MAX_CURVATUR;

         /* if(ros_gpnum == 1) */
             /* CPrintf("curvparam = %g  %d,%d\n", curvparam, nusteps, nvsteps); */
         Printf("add: u = %d, v = %d\n", nusteps, nvsteps);
      /*CPrintf("add = %d %d %d %d\n",
		curvadd[patchno][0][0], curvadd[patchno][0][1],
		curvadd[patchno][1][0], curvadd[patchno][1][1]);
      /**/
         
      }
      /* nusteps = curvadd[patchno][0]; */
      /* nvsteps = curvadd[patchno][1]; */
   }
/* e.g Find max of lengths of v = 0 and v = 1 -- u marches along that dir */

   div = 0;
   if(!insteps[0][0])
   {
      linsteps[0][0] = insteps[0][0] = curvadd[patchno][0][0] +
		NSTEPS + (udegree*SQRT2*maxu[0]*fov)/(screentol*minwu[0]);
      if(insteps[0][0] >= ULTI_POINTS)
         linsteps[0][0] = insteps[0][0] =  ULTI_POINTS-1;
   }
   j = linsteps[0][0];
   if(!insteps[0][1])
   {
      linsteps[0][1] = insteps[0][1] = curvadd[patchno][0][1] +
      NSTEPS + (udegree*SQRT2*maxu[vdegree]*fov)/ (screentol*minwu[vdegree]);
      if(insteps[0][1] >= ULTI_POINTS)
         linsteps[0][1] = insteps[0][1] =  ULTI_POINTS-1;
   }
   if(!udepth) /* If udivided don't subdivide v further */
   {
      for(i = 1; i < vdegree; i++)
      {
         k = curvadd[patchno][0][1] + NSTEPS +(udegree*SQRT2*maxu[i]*fov)/(screentol*minwu[i]); 
         if(k >= ULTI_POINTS)
            k =  ULTI_POINTS-1;
         l = j - k;
         if(l > LARGE_ADJ_DIFF || l < -LARGE_ADJ_DIFF)
         {
            /* div = V; */
            /* break; */
         }
         j = k;
      }
	/* Should also check for diff between j and linsteps[0][1]
           for LARGE_ADJ_DIFF  */
      l = linsteps[0][1] - linsteps[0][0];
      if(l > LARGE_END_DIFF || l < -LARGE_END_DIFF)
         div = V;
   }

   if(!insteps[1][0])
   {
      linsteps[1][0] = insteps[1][0] = curvadd[patchno][1][0] +
       NSTEPS + (vdegree*SQRT2*maxv[0]*fov)/(screentol*minwv[0]);
      if(insteps[1][0] >= ULTI_POINTS)
         linsteps[1][0] = insteps[1][0] =  ULTI_POINTS-1;
   }
   j = linsteps[1][0];
   if(!insteps[1][1])
   {
      linsteps[1][1] = insteps[1][1] = curvadd[patchno][1][1] +
      NSTEPS + (vdegree*SQRT2*maxv[udegree]*fov)/ (screentol*minwv[udegree]);
      if(insteps[1][1] >= ULTI_POINTS)
         linsteps[1][1] = insteps[1][1] =  ULTI_POINTS-1;
   }
   if(!div)
      if(linsteps[1][0] >= MAX_NO_POINTS || linsteps[1][1] >= MAX_NO_POINTS)
         div = V;


   if(!div)
   {
      for(i=1; i< udegree; i++)
      {
         k = curvadd[patchno][1][1] + NSTEPS+(vdegree*SQRT2*maxv[i]*fov)/(screentol*minwv[i]);
         if(k >= ULTI_POINTS)
            k =  ULTI_POINTS-1;
         l = k - j;
         if(l > LARGE_ADJ_DIFF || l < -LARGE_ADJ_DIFF)
         {
            div = U;
            break;
         }
         j = k;
      }
	/* Should also check for diff between j and linsteps[1][1]
           for LARGE_ADJ_DIFF  */
      l = linsteps[1][1] - linsteps[1][0];
      if(l > LARGE_END_DIFF || l < -LARGE_END_DIFF ||
         linsteps[0][0] >= MAX_NO_POINTS || linsteps[0][1] >= MAX_NO_POINTS)
         div = U;
         /* {div = U; udepth++;} */
   }
   /* Not divide when linsteps < .. and udepth+vdepth == MAX_DEPTH ? */
   /* if(div && udepth+vdepth < 7) */
   if(subdiv && div && udepth+vdepth < 7)
   {
      init[patchno] = 0; init[numpatches] = 0;
      subdivide(cntrl, cntrl2, udegree, vdegree, div, coord, DIV_POINT);
      tmp2 = 2*tolerance;
      if(div == U)
      {
         udepth++;
	 if(insteps[0][0]&1)
	 {
	    /* tmp1 = 1/(WTYPE)(insteps[0][0]); */
	    corners1 = corners|UV10; corners2 = corners|UV00;
	    /* triangle(cntrl, cntrl2, tmp1, 0, tmp2, U, udegree, coord); */
	    /* triangle(cntrl, cntrl2, 1-tmp1, 0.0, tmp1, 0.0, 0.0, tmp2); */
	 }
	 else {corners1 = corners; corners2 = corners;}
         /* insteps[0][0] >>= 1; */
         /* insteps[1][0] = 0; */
	 if(insteps[0][1]&1)
	 {
	    /* tmp1 = 1/(WTYPE)(insteps[0][1]); */
	    corners1 |= UV11; corners2 |= UV01;
	    /* triangle(cntrl, cntrl2,tmp1, vdegree,tmp2, U, udegree, coord); */
	    /* triangle(cntrl, cntrl2, 1-tmp1, 1.0, tmp1, 1.0, 0.0, 1-tmp2); */
	 }
         /* insteps[0][1] >>= 1; */
         j = insteps[1][1];
         insteps[1][1] = 0;
         upath <<= 1;
      } else
      {
         vdepth ++;
	 if(insteps[1][0]&1)
	 {
	    /* tmp1 = 1/(WTYPE)(insteps[1][0]); */
            corners1 = corners|UV01; cut1 = cut | UV01;
	    corners2 = corners|UV00; cut2 = cut | UV00;
	    /* triangle(cntrl, cntrl2, tmp1, 0, tmp2, V, vdegree, coord); */
	    /* triangle(cntrl, cntrl2, 0.0, 1-tmp1, 0.0, tmp1, tmp2, 0.0); */
	 }
	 else {corners1 = corners2 = corners; cut1 = cut2 = cut;}
         /* insteps[1][0] >>= 1; */
         /* insteps[0][0] = 0; */
	 if(insteps[1][1]&1)
	 {
	    /* tmp1 = 1/(WTYPE)(insteps[1][1]); */
	    corners1 |= UV11; cut1 |= UV11; 
	    corners2 |= UV10; cut2 |= UV10;
	    /* triangle(cntrl,cntrl2, tmp1, udegree, tmp2, V,vdegree, coord); */
	    /* triangle(cntrl, cntrl2, 1.0, 1-tmp1, 1.0, tmp1, 1-tmp2, 0.0); */
	 }
         /* insteps[1][1] >>= 1; */
         j = insteps[0][1];
         insteps[0][1] = 0;
         vpath <<= 1;
      } /* Corner cut or not: insteps need to be filled */
 
      statcolor = 61;

      /* if(arbit == 1 || arbit == 0) */
      bez_surface(cntrl, udegree, vdegree, first, insteps, udepth, vdepth,
            upath, vpath, tmp2, curvparam, divparam, corners1, cut1, dglob);
      if(div == U) {i = 1; upath |= 1;}
      else         {i = 0; vpath |= 1;}
      insteps[i][1] = j;
      j = insteps[i][0];
      insteps[i][0] = 0;
		/* can fill [i][0] with [i][1] instead of making it = 0 */

      statcolor = 161;

      /* if(arbit == 2 || arbit == 0) */
      bez_surface(cntrl2, udegree, vdegree, first, insteps, udepth, vdepth,
            upath, vpath, tmp2, curvparam, divparam, corners2, cut2, dglob);
      insteps[i][0] = j;
   }
   else
   { /* insteps[0][0], [0][1] / by 2**udepth */
     /* insteps[1][0], [1][1] / by 2**vdepth */
      /* *pnusteps = nusteps; *pnvsteps = nvsteps; */
      /* print */
      CPrintf("R%d(%d): insteps = %d %d %d %d",ros_gpnum, patchno, insteps[0][0],
                           insteps[0][1], insteps[1][0], insteps[1][1]);
      /**/CPrintf("add = %d %d %d %d\n",
		curvadd[patchno][0][0], curvadd[patchno][0][1],
		curvadd[patchno][1][0], curvadd[patchno][1][1]);
      /**/
      nusteps=(insteps[0][0]>insteps[0][1])? insteps[0][0]:insteps[0][1];
      nvsteps=(insteps[1][0]>insteps[1][1])? insteps[1][0]:insteps[1][1];
      if(upath || vpath) {patchno = numpatches; numpatches++;}
      Bez_surface(cntrl, udegree, vdegree, nusteps, nvsteps, insteps,
       udepth, vdepth, upath, vpath, dglob, coord, corners, cut, tolerance);
   }


}

subdivide(cntrl, cntrl2, udegree, vdegree, div, coord, t)
WTYPE cntrl[MAX_DEGREE][MAX_DEGREE][WCOORD];
WTYPE cntrl2[MAX_DEGREE][MAX_DEGREE][WCOORD], t;
int div;
{
int i, j, i1, i2, li1, li2, ri1, ri2, deg, curve, num_curves, curve_deg;
WTYPE local[MAX_DEGREE][WCOORD], s;

   if(rc_refine_pass() == 1)
      printf("%d(%d): Subdividing along %c..\n", ros_gpnum, patchno,
                   (div == 1)? 'u':'v');
   s = 1-t;
   if(div == U)      {num_curves = vdegree; curve_deg = udegree;}
   else if(div == V) {num_curves = udegree; curve_deg = vdegree;}
   else		     return;
   for(curve = 0; curve <= num_curves; curve++)
   {
      if(div == U) {li2 = ri2 = i2 = curve; ri1 = curve_deg;} /* [deg][curve] */
      else	   {li1 = ri1 = i1 = curve; ri2 = curve_deg;} /* [curve][deg] */

      for(deg = 0; deg <= curve_deg; deg++)
	 {
            if(div == U) i1 = deg;
            else	 i2 = deg;
            for(j = 0; j <= coord; j++)
	       local[deg][j] = cntrl[i1][i2][j];
	 }

      for(j=0; j<WCOORD; j++)
         cntrl2[ri1][ri2][j] = cntrl[ri1][ri2][j];

      for(deg = 1; deg <= curve_deg; deg++)
      {
         if(div == U) {li1 = deg; ri1 = curve_deg-deg;}
         else         {li2 = deg; ri2 = curve_deg-deg;}

	 for(i=0; i<= curve_deg-deg; i++)
	 {
            if(div == U) i1 = i;
            else	 i2 = i;

            for(j=0; j<coord; j++)
               local[i][j]  = s*local[i][j] + t*local[i+1][j];

            /* if(coord == WCOORD) */
               /* for(j=0; j<COORD; j++) */
                  /* local[i][j]  /= local[i][COORD]; */

            /* cntrl[i1][i2][j]  = s*cntrl[i1][i2][j] + t*cntrl[i12][i22][j]; */
	 }

         for(j=0; j<coord; j++)
	 {
            cntrl[li1][li2][j] = local[0][j];
	    cntrl2[ri1][ri2][j] = local[curve_deg-deg][j];
	 }
         if(coord == COORD)
	    cntrl2[ri1][ri2][COORD] = 1.0;
      }
   }
}

fillcurve(cntrl, cntrl2, cntrl3, udegree, vdegree, nsteps, pts, norms,
          v, lu, ru, coord)
WTYPE cntrl[][MAX_DEGREE][WCOORD], v, lu, ru;
WTYPE cntrl2[][MAX_DEGREE][WCOORD], cntrl3[][MAX_DEGREE][WCOORD];
	/* cntrl, cntrl2 & cntrl3 are filled correctly for uorv = U */
POINT pts[], norms[];
int   udegree, vdegree, nsteps, coord;
{
POINT newctrl[MAX_DEGREE];
POINT tmpn1[MAX_NO_POINTS];
int   i,j;

    print("Calculating\n");

    for(i=0; i<=udegree; i++)
       bez_pt(cntrl[i], vdegree, v, newctrl[i], coord);
    bez_curve(newctrl, udegree, nsteps, pts, lu,ru, coord);

    for(i=0; i<udegree; i++)
       bez_pt(cntrl2[i], vdegree, v, newctrl[i], coord);
    bez_curve(newctrl,udegree-1, nsteps, tmpn1, lu,ru, coord);

    for(i=0; i<=udegree; i++)
       bez_pt(cntrl3[i], vdegree-1, v, newctrl[i], coord);
    bez_curve(newctrl, udegree, nsteps, norms, lu,ru, coord);

    for(i=0; i<= nsteps; i++)
    {
       if(coord == WCOORD)
          for(j=0; j<COORD; j++)
          {
             pts[i][j] /= pts[i][COORD];

	     tmpn1[i][j] = (tmpn1[i][j] - pts[i][j]*
             tmpn1[i][COORD])/pts[i][COORD];
   
	     norms[i][j] = (norms[i][j] - pts[i][j]*
             norms[i][COORD])/pts[i][COORD];
          }
       crossp(tmpn1[i], norms[i], newctrl[0]);
       normalize(newctrl[0], norms[i]);
    }
    if(nsteps >= MAX_NO_POINTS) printf("Failing\n");
}

fillcurve0(cntrl, cntrl2, cntrl3, udegree, vdegree, nsteps, pts, norms,
          v, lu, ru, coord, uorv)
WTYPE cntrl[][MAX_DEGREE][WCOORD], v, lu, ru;
WTYPE cntrl2[][MAX_DEGREE][WCOORD], cntrl3[][MAX_DEGREE][WCOORD];
	/* cntrl, cntrl2 & cntrl3 are filled correctly for uorv = U */
POINT pts[], norms[];
int   udegree, vdegree, nsteps, coord, uorv;
{
POINT newctrl[MAX_DEGREE];
POINT tmpn1[MAX_NO_POINTS];
int   deg, idx, i,j;

    print("Calculating\n");

    idx = 0;
    if(uorv == V)
    {
       if(v == 1) idx = vdegree;
       deg = udegree;
    } else
    {
       if(v == 1) idx = udegree;
       deg = vdegree;
    }
    
    if(uorv == V)
    for(i=0; i<=udegree; i++)
       for(j=0; j<coord; j++)
          newctrl[i][j] = cntrl[i][idx][j];
   else
    for(i=0; i<=vdegree; i++)
       for(j=0; j<coord; j++)
          newctrl[i][j] = cntrl[idx][i][j];
   /* for(i=0; i<=udegree; i++) */
   /* print("C1:%g %g %g ## ", newctrli][0],newctrl[i][1],newctrl[i][2]); */
    bez_curve(newctrl, deg, nsteps, pts, lu,ru, coord);

    if(uorv == V)
    {
       if(v == 1) idx = vdegree;
       deg = udegree-1;
    } else
    {
       if(v == 1) idx = udegree-1;
       deg = vdegree;
    }

    if(uorv == V)
    for(i=0; i<udegree; i++)
       for(j=0; j<coord; j++)
          newctrl[i][j] = cntrl2[i][idx][j];
    else
    for(i=0; i<=vdegree; i++)
       for(j=0; j<coord; j++)
          newctrl[i][j] = cntrl2[idx][i][j];
   /* for(i=0; i<=udegree; i++) */
   /* print("C2:%g %g %g ## ", newctrli][0],newctrl[i][1],newctrl[i][2]); */
    bez_curve(newctrl,deg, nsteps, tmpn1, lu,ru, coord);

    if(uorv == V)
    {
       if(v == 1) idx = vdegree-1;
       deg = udegree;
    } else
    {
       if(v == 1) idx = udegree;
       deg = vdegree-1;
    }

    if(uorv == V)
    for(i=0; i<=udegree; i++)
       for(j=0; j<coord; j++)
          newctrl[i][j] = cntrl3[i][idx][j];
    else
    for(i=0; i<vdegree; i++)
       for(j=0; j<coord; j++)
          newctrl[i][j] = cntrl3[idx][i][j];
   /* for(i=0; i<=udegree; i++) */
   /* print("C3:%g %g %g ## ", newctrli][0],newctrl[i][1],newctrl[i][2]); */
    bez_curve(newctrl, deg, nsteps, norms, lu,ru, coord);

    for(i=0; i<= nsteps; i++)
    {
       if(coord == WCOORD)
          for(j=0; j<COORD; j++)
          {
             pts[i][j] /= pts[i][COORD];

	     tmpn1[i][j] = (tmpn1[i][j] - pts[i][j]*
             tmpn1[i][COORD])/pts[i][COORD];
   
	     norms[i][j] = (norms[i][j] - pts[i][j]*
             norms[i][COORD])/pts[i][COORD];
          }
       crossp(tmpn1[i], norms[i], newctrl[0]);
       normalize(newctrl[0], norms[i]);
    }
    if(nsteps >= MAX_NO_POINTS) printf("Failing\n");
}
