/* 
 * linprog.c
 *
 * Copyright (c) 1990 Michael E. Hohmeyer, 
 *       hohmeyer@miro.berkeley.edu, 
 * Permission is granted to modify and re-distribute this code in any manner
 * as long as this notice is preserved.  All standard disclaimers apply.
 *
 */
#ifdef CPP
extern "C" {
void randperm(int i, int *p);
int linprog(float *v, int istart,int n, float *num, float *den, int dim, float *opt,
	float *work);
}
#endif
/* status from lp_intersect or linprog */ 
#define INFEASIBLE 0
#define MINIMUM 1
#define UNBOUNDED 2
#define AMBIGUOUS 3

/* status from plane_down */
#define REDUNDANT 0
#define PROPER 1

#include "tol.h"

